#define BASS_RETRACT 2
#define BASS_EXTEND 3
#define BASS_IN 4
#define SNARE_IN 5
#define SNARE_LEFT 6
#define SNARE_RIGHT 7
#define LED 13

#include "WProgram.h"
void setup();
void loop();
int snareComplement(int otherSnare);
int nextSnare = 6;//CAN ALSO BE 7 SOMETIMES ZOMG!!!

int bassCtr = 0;
int snareCtrL = 0;
int snareCtrR = 0;

void setup()
{
  pinMode(BASS_RETRACT, OUTPUT);
  digitalWrite(BASS_RETRACT,LOW);
  pinMode(BASS_EXTEND, OUTPUT);
  digitalWrite(BASS_EXTEND,LOW);
  pinMode(LED, OUTPUT);
  digitalWrite(LED,LOW);
  pinMode(BASS_IN, INPUT);
  digitalWrite(BASS_IN,HIGH);
  pinMode(SNARE_IN, INPUT);
  digitalWrite(SNARE_IN,HIGH);
  
  pinMode(6, OUTPUT);//SNARE LEFT
  pinMode(7, OUTPUT);//SNARE RIGHT
  digitalWrite(6,LOW);
  digitalWrite(7,LOW);
}

void loop()
{
  //BASSBOT!!!!!!!!
  if(digitalRead(BASS_IN)==LOW && bassCtr == 0){//NOTE REVERSE LOGIC
    digitalWrite(BASS_EXTEND,HIGH);
    digitalWrite(BASS_RETRACT,LOW);
    digitalWrite(LED,HIGH);
    bassCtr = 200;
  }
  if(bassCtr == 100){//AFTER 100ms
    digitalWrite(BASS_EXTEND,LOW);
    digitalWrite(BASS_RETRACT,HIGH);
    digitalWrite(LED,LOW);
  }
  if(bassCtr == 1){//AFTER ANOTHER 100ms
    digitalWrite(BASS_RETRACT,LOW);
  }
  if(bassCtr > 0){
    --bassCtr;
  }
  
  //SNAREBOT!!!!!!!!
  if(digitalRead(SNARE_IN) == LOW && nextSnare == SNARE_LEFT && snareCtrL == 0){
    snareCtrL = 115;
  }
  if(digitalRead(SNARE_IN) == LOW && nextSnare == SNARE_RIGHT && snareCtrR == 0){
    snareCtrR = 115;
  }
  
  if(snareCtrL == 115){//NOTE REVERSE LOGIC
    digitalWrite(SNARE_LEFT,HIGH);
    digitalWrite(LED,HIGH);
  }
  if(snareCtrL == 65){
    nextSnare = 7;
  }
  if(snareCtrL == 25){//after 90ms
    digitalWrite(SNARE_LEFT,LOW);
    digitalWrite(LED,LOW);
  }
  if(snareCtrL > 0){
    --snareCtrL;
  }
  if(snareCtrR == 115){//NOTE REVERSE LOGIC
    digitalWrite(SNARE_RIGHT,HIGH);
    digitalWrite(LED,HIGH);
  }
  if(snareCtrR == 65){
    nextSnare = 6;
  }
  if(snareCtrR == 25){//after 90ms
    digitalWrite(SNARE_RIGHT,LOW);
    digitalWrite(LED,LOW);
  }
  if(snareCtrR > 0){
    --snareCtrR;
  }
  
  delay(1);
}

int snareComplement(int otherSnare){
  return 6+((otherSnare+1)%2);
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

